package com.kexue.skills.service;

import com.github.pagehelper.PageInfo;
import com.kexue.skills.entity.CmsTag;
import com.kexue.skills.entity.dto.CmsTagDto;

import java.util.List;

/**
 * (CmsTag)表服务接口
 *
 * @author 王志维
 * @since 2025-02-21 23:01:48
 */
public interface CmsTagService extends BaseService {
    /**
     * 分页查询
     *
     * @param queryDto 筛选条件
     * @return 查询结果
     */
    PageInfo<CmsTag> getPageList(CmsTagDto queryDto);

    /**
     * 查询列表
     *
     * @param queryDto 筛选条件
     * @return 查询结果
     */
    List<CmsTag> getList(CmsTagDto queryDto);

    /**
     * 通过主键查询单条数据
     *
     * @param tagId 主键
     * @return 实例对象
     */
    CmsTag queryById(Long tagId);

    /**
     * 新增数据
     *
     * @param cmsTag 实例对象
     * @return 实例对象
     */
    CmsTag insert(CmsTag cmsTag);

    /**
     * 更新数据
     *
     * @param cmsTag 实例对象
     * @return 实例对象
     */
    CmsTag update(CmsTag cmsTag);

    /**
     * 通过主键逻辑删除
     *
     * @param tagId 主键
     * @param updateBy 更新人
     * @return 影响行数
     */
    int logicDeleteById(Long tagId, String updateBy);

    /**
     * 通过主键物理删除
     *
     * @param tagId 主键
     * @return 影响行数
     */
    int deleteById(Long tagId);

    /**
     * 根据分类ID查询标签列表
     *
     * @param categoryId 分类ID
     * @return 标签列表
     */
    List<CmsTag> getTagsByCategoryId(Long categoryId);
}